Bug 1610554 (perl-Crypt-HSXKPasswd) - Review Request: hsxkpasswd - Secure memorable password generator
Summary: Review Request: hsxkpasswd - Secure memorable password generator
Keywords:
Status: CLOSED ERRATA
Alias: perl-Crypt-HSXKPasswd
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-07-31 22:03 UTC by Robert-André Mauchin
Modified: 2018-08-26 17:40 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-08-25 21:48:11 UTC
zbyszek: fedora-review+


Attachments (Terms of Use)

Description Robert-André Mauchin 2018-07-31 22:03:08 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/hsxkpasswd/fedora-rawhide-x86_64/00782843-hsxkpasswd/hsxkpasswd.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/hsxkpasswd/fedora-rawhide-x86_64/00782843-hsxkpasswd/hsxkpasswd-3.6-1.fc29.src.rpm

Description:
A secure memorable password generator inspired by the wonderful XKCD
webcomic at http://www.xkcd.com/ and Steve Gibson's Password Haystacks page
at https://www.grc.com/haystack.htm. This is the Perl module that powers
https://www.xkpasswd.net.


Fedora Account System Username: eclipseo

Comment 1 Iñaki Ucar 2018-08-01 08:45:58 UTC
This is an informal review. I went through the package and found some minor
issues:

- The comment in the SPEC should reflect that two dictionaries are BSD too
(EN, ES).

- The README file is ISO-8859, not UTF-8.

- The dictionaries (share dir) are 35 MB in 12 files. Another more experienced
reviewer should evaluate whether they should go in a -doc subpackage.



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package does not own files or directories owned by other packages.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: hsxkpasswd-3.6-1.fc28.noarch.rpm
          hsxkpasswd-3.6-1.fc28.src.rpm
hsxkpasswd.noarch: W: spelling-error %description -l en_US webcomic -> web comic, web-comic, economic
hsxkpasswd.noarch: W: file-not-utf8 /usr/share/doc/hsxkpasswd/README
hsxkpasswd.src: W: spelling-error %description -l en_US webcomic -> web comic, web-comic, economic
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
hsxkpasswd.noarch: W: spelling-error %description -l en_US webcomic -> web comic, web-comic, economic
hsxkpasswd.noarch: W: invalid-url URL: https://www.bartbusschots.ie/s/publications/software/xkpasswd/ <urlopen error [Errno -2] Name or service not known>
hsxkpasswd.noarch: W: file-not-utf8 /usr/share/doc/hsxkpasswd/README
1 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
hsxkpasswd (rpmlib, GLIBC filtered):
    /usr/bin/perl
    perl(:MODULE_COMPAT_5.26.2)
    perl(:VERSION)
    perl(Carp)
    perl(Clone)
    perl(Crypt::HSXKPasswd)
    perl(Crypt::HSXKPasswd::Dictionary)
    perl(Crypt::HSXKPasswd::Dictionary::Basic)
    perl(Crypt::HSXKPasswd::Helper)
    perl(Crypt::HSXKPasswd::RNG)
    perl(Crypt::HSXKPasswd::RNG::Basic)
    perl(Crypt::HSXKPasswd::RNG::Data_Entropy)
    perl(Crypt::HSXKPasswd::RNG::DevUrandom)
    perl(Crypt::HSXKPasswd::RNG::Math_Random_Secure)
    perl(Crypt::HSXKPasswd::Types)
    perl(Data::Dumper)
    perl(DateTime)
    perl(Encode)
    perl(English)
    perl(Exporter)
    perl(Fatal)
    perl(File::HomeDir)
    perl(Getopt::Long)
    perl(JSON)
    perl(List::MoreUtils)
    perl(Math::BigInt)
    perl(Math::Round)
    perl(Module::Load)
    perl(Pod::Usage)
    perl(Readonly)
    perl(Scalar::Util)
    perl(Text::Unidecode)
    perl(Type::Library)
    perl(Type::Params)
    perl(Type::Tiny)
    perl(Types::Standard)
    perl(base)
    perl(lib)
    perl(parent)
    perl(strict)
    perl(utf8)
    perl(version)
    perl(warnings)



Provides
--------
hsxkpasswd:
    hsxkpasswd
    perl(Crypt::HSXKPasswd)
    perl(Crypt::HSXKPasswd::Dictionary)
    perl(Crypt::HSXKPasswd::Dictionary::Basic)
    perl(Crypt::HSXKPasswd::Dictionary::DE)
    perl(Crypt::HSXKPasswd::Dictionary::EN)
    perl(Crypt::HSXKPasswd::Dictionary::ES)
    perl(Crypt::HSXKPasswd::Dictionary::FR)
    perl(Crypt::HSXKPasswd::Dictionary::IT)
    perl(Crypt::HSXKPasswd::Dictionary::NL)
    perl(Crypt::HSXKPasswd::Dictionary::PT)
    perl(Crypt::HSXKPasswd::Dictionary::System)
    perl(Crypt::HSXKPasswd::Helper)
    perl(Crypt::HSXKPasswd::RNG)
    perl(Crypt::HSXKPasswd::RNG::Basic)
    perl(Crypt::HSXKPasswd::RNG::Data_Entropy)
    perl(Crypt::HSXKPasswd::RNG::DevUrandom)
    perl(Crypt::HSXKPasswd::RNG::Math_Random_Secure)
    perl(Crypt::HSXKPasswd::RNG::RandomDotOrg)
    perl(Crypt::HSXKPasswd::Types)
    perl(Crypt::HSXKPasswd::Util)



Source checksums
----------------
http://www.cpan.org/authors/id/B/BA/BARTB/Crypt-HSXKPasswd-v3.6.tar.gz :
  CHECKSUM(SHA256) this package     : 959dcc5f9f011bf00b85ad22df566b7ab2bf5ea1d362b0de0fb5ae29fbc458b3
  CHECKSUM(SHA256) upstream package : 959dcc5f9f011bf00b85ad22df566b7ab2bf5ea1d362b0de0fb5ae29fbc458b3

Comment 2 Peter Oliver 2018-08-01 17:46:26 UTC
(In reply to Iñaki Ucar from comment #1)

> - The dictionaries (share dir) are 35 MB in 12 files. Another more
> experienced
> reviewer should evaluate whether they should go in a -doc subpackage.

I'm not going to claim to be more experienced, but it seems to me that it would make more sense to split them out into langpacks rather than a doc subpackage.  https://fedoraproject.org/wiki/Packaging:Langpacks

Comment 3 Iñaki Ucar 2018-08-01 18:23:18 UTC
I was looking for similar precedents, but there are not many of them. For instance, cracklib provides cracklib-dicts.

AFAICT, all the -langpack packages currently in Fedora are translations or add some kind of language-related functionality. This is not the case, and I think it could be confusing for the user.

My reasoning to suggest -doc was that this package provides prebuilt dictionaries as modules like Crypt::HSXKPasswd::Dictionary::EN, so one could argue that those dictionaries are the reference for such modules: what you can find there in plain text.

Comment 4 Zbigniew Jędrzejewski-Szmek 2018-08-07 10:17:52 UTC
So... if I read the script to build .pms, /usr/share/doc/hsxkpasswd/xscripts/generateDictionaries.pl correctly, it converts sample_dict_DE.txt into DE.pm and so on, for each language. So the "sample_dict_*.txt" files should be considered sources.

Then they are packaged twice:
$ rpm -ql hsxkpasswd-3.6-1.fc27.noarch|grep sample
/usr/share/doc/hsxkpasswd/share/sample_config.json
/usr/share/doc/hsxkpasswd/share/sample_dict_DE.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_EN.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_ES.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_FR.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_IT.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_NL.txt
/usr/share/doc/hsxkpasswd/share/sample_dict_PT.txt
/usr/share/doc/hsxkpasswd/share/sample_hsxkpasswdrc
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_config.json
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_DE.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_EN.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_ES.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_FR.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_IT.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_NL.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_dict_PT.txt
/usr/share/perl5/vendor_perl/auto/share/dist/Crypt-HSXKPasswd/sample_hsxkpasswdrc

I don't think those files are useful for anything, just drop them from the binary package. Similarly, the script could be considered a build script and dropped from documentation too.

Comment 5 Robert-André Mauchin 2018-08-07 16:08:57 UTC
Thanks for your comments!

I updated the License comment regarding the dictionaries as per Iñaki Ucar comment.

I removed the source dictionaries and the build script.

Spec URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/hsxkpasswd/fedora-rawhide-x86_64/00785457-hsxkpasswd/hsxkpasswd.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/hsxkpasswd/fedora-rawhide-x86_64/00785457-hsxkpasswd/hsxkpasswd-3.6-1.fc29.src.rpm

Comment 6 Zbigniew Jędrzejewski-Szmek 2018-08-08 14:28:24 UTC
+ package name is OK
+ latest version
+ license is acceptable for Fedora (BSD and GPLv2+)
+ license is specified correctly
+ license breakdown in a comment in the spec file
+ builds and install correctly
+ BR/R/P look OK
+ perl Requires line is present
+ fedora-review and rpmlint find no important issues

Package is APPROVED.

rpmlint output:
hsxkpasswd.noarch: W: spelling-error %description -l en_US webcomic -> web comic, web-comic, economic
hsxkpasswd.noarch: W: file-not-utf8 /usr/share/doc/hsxkpasswd/README
Error checking signature of hsxkpasswd-3.6-1.fc29.noarch.rpm: hsxkpasswd-3.6-1.fc29.noarch.rpm: digests SIGNATURES NOT OK
hsxkpasswd.src: W: spelling-error %description -l en_US webcomic -> web comic, web-comic, economic
Error checking signature of hsxkpasswd-3.6-1.fc29.src.rpm: hsxkpasswd-3.6-1.fc29.src.rpm: digests SIGNATURES NOT OK
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
→ all unimportant.

Comment 7 Gwyn Ciesla 2018-08-14 14:16:35 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/hsxkpasswd

Comment 8 Fedora Update System 2018-08-14 14:49:49 UTC
hsxkpasswd-3.6-1.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-6871f34cfa

Comment 9 Fedora Update System 2018-08-14 14:50:15 UTC
hsxkpasswd-3.6-1.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-41a3b254c8

Comment 10 Fedora Update System 2018-08-14 20:36:58 UTC
hsxkpasswd-3.6-1.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-6871f34cfa

Comment 11 Fedora Update System 2018-08-14 22:42:58 UTC
hsxkpasswd-3.6-1.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-41a3b254c8

Comment 12 Fedora Update System 2018-08-25 21:48:11 UTC
hsxkpasswd-3.6-1.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2018-08-25 22:03:27 UTC
hsxkpasswd-3.6-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2018-08-26 04:50:31 UTC
hsxkpasswd-3.6-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 15 Fedora Update System 2018-08-26 17:40:10 UTC
hsxkpasswd-3.6-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.